/*
 * cexeclib.h
 * 
 * Copyright (C) February, 1998 Sergei Viznyuk <sergei@phystech.com>
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CEXECLIB_H
#define CEXECLIB_H

#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <unistd.h>
#include <errno.h>

int cexecve(int (*cdialog)(int [3][2]),const char *filename,
	    char *const *argc,char *const *argv);
int cexecl(int (*cdialog)(int [3][2]),const char *path,const char *argc,...);
int cexeclp(int (*cdialog)(int [3][2]),const char *filename,const char *argc,...);
char *cexpect(char *c,char *buf,int bufsiz,int s,time_t tv_sec,time_t tv_usec);
int creply(char *buf,int bufsiz,int s,time_t tv_sec,time_t tv_usec);
int creadok(int s,time_t tv_sec,time_t tv_usec);
int cwriteok(int s,time_t tv_sec,time_t tv_usec);

#endif
