/*
 * cgiexec.c
 * Copyright (C) January, 1999 Sergei Viznyuk <sv@phystech.com>
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "cexeclib.h"
#include "qsparse.h"

#define		TIME_OUT	10
#define		READ_BUF	65536
#define		WRITE_BUF	69632

char Command[512];
/*****************************************************************************/
int cdialog(sv)
int sv[3][2];
{
  char read_buf[READ_BUF],write_buf[WRITE_BUF];
  fd_set fs,efs;
  struct timeval tv;
  int i;

  FD_ZERO(&fs);
  FD_ZERO(&efs);
  FD_SET(sv[1][0],&fs);
  FD_SET(sv[1][0],&efs);
  FD_SET(sv[2][0],&fs);
  FD_SET(sv[2][0],&efs);
  tv.tv_sec=TIME_OUT;
  tv.tv_usec=0;

  errno = 0;
  if ( select(sv[2][0]+1,&fs,NULL,&efs,&tv) == -1 ) return -1;
  setbuffer(stdout,write_buf,WRITE_BUF);
  fprintf(stdout,"HTTP-Version: HTTP/1.1\nContent-Type: text/html\n\n\
<HTML>\n<HEAD>\n<TITLE>%s</TITLE>\n</HEAD>\n\
<BODY BGCOLOR=\"#C0C0C0\">\n",Command);
  if ( FD_ISSET(sv[1][0],&fs) && (i=read(sv[1][0],read_buf,READ_BUF))>0 )
    {
      read_buf[i]=0;
      fprintf(stdout,"<TABLE ROWS=2 COLS=1 WIDTH=100%% BORDER=3>\n\
<TH ALIGN=CENTER>%s -- output</TH><TR ALIGN=LEFT>\n\
<TD NOWRAP><PRE>%s",Command,read_buf);
      while ( (i=read(sv[1][0],read_buf,READ_BUF)) > 0 )
        fwrite(read_buf,i,1,stdout);
      fprintf(stdout,"</PRE></TABLE>\n");
    }
  if ( FD_ISSET(sv[2][0],&fs) && (i=read(sv[2][0],read_buf,READ_BUF))>0 )
    {
      read_buf[i]=0;
      fprintf(stdout,"<P><TABLE ROWS=2 COLS=1 WIDTH=100%% BORDER=3 BGCOLOR=\"#F0B0B0\">\n\
<TH>%s -- errors</TH><TR ALIGN=LEFT>\n<TD NOWRAP><PRE>%s\n",Command,read_buf);
      while ( (i=read(sv[2][0],read_buf,READ_BUF)) > 0 )
        {
	  read_buf[i]=0;
          fprintf(stdout,"%s",read_buf);
        }
      fprintf(stdout,"</PRE></TABLE>\n");
    }
  return 0;
}
/*****************************************************************************/
int main(argn,argc,argv)
int argn;
char *argc[],*argv[];
{
  char *s,*ac[256];
  querystr qs;
  int i,j;

  if ( qsparse(getenv("QUERY_STRING"),&qs) <= 0 )
    {
ern:  fprintf(stdout,"HTTP-Version: HTTP/1.1\nContent-Type: text/html\n\n\
<H3>No command specified</H3>\n");
      exit(1);
    }
  for (j=0;j<qs.num;j++)
    if ( ! memcmp(qs.key[j],"command",7) )
      goto smps;
  goto ern;
smps:
  memset(Command,0,512);
  memcpy(Command,qs.val[j],qs.val_len[j]);
  s=qs.val[j];
  ac[0]=s;
  while ( *s>32 && s-qs.val[j]<qs.val_len[j] )
    if ( *s == '/' )
      ac[0]= ++s;
    else
      ++s;
  *s++ =0;
  i=1;
  while ( s-qs.val[j]<qs.val_len[j] )
    if ( *s > 32 )
      {
        if ( i < 256 ) ac[i++]=s++;
	while ( *s>32 && s-qs.val[j]<qs.val_len[j] ) s++;
      }
    else
      *s++ = 0;
  if ( cexecve(&cdialog,ac[0],ac,argv) )
    fprintf(stdout,"<P><B>Status:</B> unable to execute the command line: <B>%s</B><P>\n<HR>",
    Command);
  fprintf(stdout,
  "<FONT SIZE=1>&#169;1999 PhysTech, Inc. All rights reserved. Last change: Jan 23, 1999</FONT></BODY></HTML>\n");
  exit(0);
}
