/*
 * qsparse.c
 * Copyright (C) August, 1996 Sergei Viznyuk <sv@phystech.com>
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include "qsparse.h"
/*****************************************************************************/
int qsparse(qb,qs)
char *qb;
querystr *qs;
{
int s;
char *c=qb;
int i=0;

errno=0;
if ( qb == NULL || qs == NULL )
  {
    errno = EINVAL;
    return -1;
  }
qs->num=0;
qs->key[0]=c;

while ( *c && i<QUERYNUM )
  switch ( *c )
    {
      case '=':
        qs->key_len[i]=c-qs->key[i];
	*c++ = 0;
	qs->val[i++]=c;
	break;
      case '&':
	*c++ = 0;
	qs->key[i]=c;
	break;
      default:
	c++;
    }
qs->num=i;
for (i=0;i<qs->num;i++)
  {
    s=0;
    c=qs->val[i];
swlp:
    switch ( *c )
      {
	case '%':
	  *(c-s)=16*((*(c+1)>64)?(*(c+1) -55):(*(c+1) -48)) +
		    ((*(c+2)>64)?(*(c+2) -55):(*(c+2) -48));
	  c+=3; s+=2;
	  goto swlp;
	case '+':
	  *(c++ -s)= ' ';
	  goto swlp;
	case 0:
	  *(c-s)=0;
	  break;
	default: 
	  *(c-s)= *c;
	  c++;
	  goto swlp;
      }
    qs->val_len[i]=c-s-qs->val[i];
  }
return qs->num;
}
